//------------------------------------------------------------------
#property copyright   "copyright mladen"
#property description "Dimi SR"
#property description "made by mladen"
#property description "original idea by Dimitri"
#property description "for more visit www.forex-tsd.com"
#property link        "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1  clrSilver
#property indicator_color2  clrLimeGreen
#property indicator_color3  clrOrange
#property indicator_color4  clrOrange
#property indicator_color5  clrOrange
#property indicator_color6  clrLimeGreen
#property indicator_width5  3
#property indicator_width6  3
#property strict

//
//
//
//
//

extern int                MaFast = 21;          // MA fast period
extern int                MaSlow = 89;          // MA slow period
extern ENUM_APPLIED_PRICE Price  = PRICE_CLOSE; // Price
extern ENUM_MA_METHOD     Method = MODE_SMA;    // MA type
extern int                Shift  = 0;           // Shift for SR high/low values
extern bool               Extend = true;        // Extend S/R lines?

double maf[],mafda[],mafdb[],mas[],sru[],srd[],state[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,mas);
   SetIndexBuffer(1,maf);
   SetIndexBuffer(2,mafda);
   SetIndexBuffer(3,mafdb);
   SetIndexBuffer(4,sru);
   SetIndexBuffer(5,srd);
   SetIndexBuffer(6,state);
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            int limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   if (state[limit]==-1) CleanPoint(limit,mafda,mafdb);            
   for (int i=limit; i>=0; i--)
   {
      mas[i]   = iMA(NULL,0,MaSlow,0,Method,Price,i);
      maf[i]   = iMA(NULL,0,MaFast,0,Method,Price,i);
      mafda[i] = EMPTY_VALUE;
      mafdb[i] = EMPTY_VALUE;
      state[i] = (maf[i]>mas[i]) ? 1  : (maf[i]<mas[i]) ? -1: state[MathMin(i,Bars-1)];
      if (i<Bars-1)
         {
            if (state[i]!=state[i+1])
            {
               if (state[i]== 1) { srd[i] = High[MathMin(i+Shift,Bars-1)]; if (!Extend) sru[i] = EMPTY_VALUE; else { sru[i] = sru[i+1]; srd[i+1] = EMPTY_VALUE; }}
               if (state[i]==-1) { sru[i] = Low [MathMin(i+Shift,Bars-1)]; if (!Extend) srd[i] = EMPTY_VALUE; else { srd[i] = srd[i+1]; sru[i+1] = EMPTY_VALUE; }}
            }
            else { sru[i] = sru[i+1]; srd[i] = srd[i+1]; }
         }   
         if (state[i] == -1) PlotPoint(i,mafda,mafdb,maf);
      }
  return(0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}